/* data.c -- BASTOC update maintenance tables

	Copyright (c) 1984 by JMI Software Consultants, Inc.
*/
#include "upd.h"

/* update maintenance modes
	These strings define the update modes that the program
	understands. The update flag(s) are looked up in this
	table and the index into this table is used as the
	second subscript into the upd table. Therefore the order
	of the entrys in this table and the upd table must correspond.
*/
GLOBAL TEXT *upd_modes[NMODE + 1] =
	{"S", "M", "C", "L", NULL};

/* These are the names of all of the BASTOC translator source
	files that are part of the binary package. The file names
	specified in the update command are looked up in this
	table to see if they are part of the translator library.
	If they are, an index of 0 is used as the first subscript
	of the upd table.
*/
GLOBAL TEXT *tran_files[] =
	{"atbls1.c", "atbls2.c", "atvar.c", "parampat.c", NULL};

/* These are the names of all of the BASTOC library source
	files that are used by the translator. The file names
	specified in the update command are looked up in this
	table to see if they are used by the translator. If they
	are, an index of 1 is used as the first subscript of 
	the upd table.

	If a file name is not found in this table or the previous
	table (tran_files), an index of 2 is used as the first
	subscript of the upd table.
*/
GLOBAL TEXT *lib_files[] =
	{"adsys.c", "daclose.c", "dacreate.c", "dafread.c", "daopen.c",
	 "daseek.c", "dawrite.c", "tmpnam.c", NULL};

/* These are the names of the BASTOC translator libraries
*/
GLOBAL TEXT *tran_libs[NMODE] =
	{"\\bastoc\\tranmbs.lib", NULL, "\\bastoc\\tranmbc.lib", NULL};

/* These are the names of the BASTOC run-time libraries
*/
GLOBAL TEXT *lib_libs[NMODE] =
	{"\\bastoc\\mbs.lib", "\\bastoc\\mbm.lib", "\\bastoc\\mbc.lib", "\\bastoc\\mbl.lib"};

/* These are the names of the C run-time libraries
*/
GLOBAL TEXT *c_libs[NMODE] =
	{NULL, NULL, NULL, NULL};

/* These are the names of the C run-time header object files
*/
GLOBAL TEXT *c_objs[NMODE] =
	{NULL, NULL, NULL, NULL};
/* These are the names of the main translator object files
*/
GLOBAL TEXT *tran_objs[NMODE] =
	{"\\bastoc\\mains.obj", NULL, "\\bastoc\\mainc.obj", NULL};

/* These are the names of the executable BASTOC translators
*/
GLOBAL TEXT *tran_pgms[NMODE] =
	{"\\bastoc\\mbas.exe", NULL, "\\bastoc\\mbasc.exe", NULL};

/* These are the flags for LC1
*/
GLOBAL TEXT *c1_flag[NMODE] =
	{"/AS", "/AM", "/AC", "/AL"};

/* These are all of the flags that BASTOC knows about
*/
GLOBAL TEXT bas_flags[] = "bcefgmnqstv";

GLOBAL BITS errors = 0;
GLOBAL BOOL file_type[3] = {0};
GLOBAL BOOL work_mode[NMODE] = {0};
GLOBAL INT mode = 0;
GLOBAL TEXT *flags = "-";
